Thu Nov 25 15:16:50 CET 2004  Norbert@...160...
  * pop-cleanup

diff -rN -u matplotlib-old/lib/matplotlib/axes.py matplotlib-new/lib/matplotlib/axes.py
--- matplotlib-old/lib/matplotlib/axes.py	2004-11-25 15:18:04.000000000 +0100
+++ matplotlib-new/lib/matplotlib/axes.py	2004-11-25 15:16:06.000000000 +0100
@@ -9,7 +9,7 @@
 from artist import Artist
 from axis import XAxis, YAxis
 from cbook import iterable, is_string_like, flatten, enumerate, True, False,\
-     allequal, dict_delall
+     allequal, dict_delall, popd
 from collections import RegularPolyCollection, PolyCollection
 from colors import colorConverter, normalize, Colormap, LinearSegmentedColormap
 import cm
@@ -1458,13 +1458,13 @@
         if len(args)==0:
             labels = [line.get_label() for line in self.lines]
             lines = self.lines
-            loc = kwargs.gry('loc', 1)
+            loc = popd(kwargs,'loc', 1)
 
         elif len(args)==1:
             # LABELS
             labels = args[0]
             lines = [line for line, label in zip(self.lines, labels)]
-            loc = kwargs.get('loc', 1)
+            loc = popd(kwargs,'loc', 1)
 
         elif len(args)==2:
             if is_string_like(args[1]) or isinstance(args[1], int):
@@ -1474,7 +1474,7 @@
             else:
                 # LINES, LABELS
                 lines, labels = args
-                loc = kwargs.get('loc', 1)
+                loc = popd(kwargs,'loc', 1)
 
         elif len(args)==3:
             # LINES, LABELS, LOC
@@ -1508,11 +1508,11 @@
         """
         if not self._hold: self.cla()
 
-        dx = {'basex': kwargs.get('basex', 10),
-              'subsx': kwargs.get('subsx', None),
+        dx = {'basex': popd(kwargs,'basex', 10),
+              'subsx': popd(kwargs,'subsx', None),
               }
-        dy = {'basey': kwargs.get('basey', 10),
-              'subsy': kwargs.get('subsy', None),
+        dy = {'basey': popd(kwargs,'basey', 10),
+              'subsy': popd(kwargs,'subsy', None),
               }
 
         self.set_xscale('log', **dx)
@@ -1600,12 +1600,14 @@
         """
         if not self._hold: self.cla()
 
-        alpha = kwargs.get('alpha', 1.0)
-        norm = kwargs.get('norm', None)
-        cmap = kwargs.get('cmap', None)        
-        vmin = kwargs.get('vmin', None)
-        vmax = kwargs.get('vmax', None)        
-        shading = kwargs.get('shading', 'faceted')
+        alpha = popd(kwargs,'alpha', 1.0)
+        norm = popd(kwargs,'norm', None)
+        cmap = popd(kwargs,'cmap', None)        
+        vmin = popd(kwargs,'vmin', None)
+        vmax = popd(kwargs,'vmax', None)        
+        shading = popd(kwargs,'shading', 'faceted')
+        if len(kwargs):
+            raise TypeError, 'Unknown argument "%s"'%kwargs.keys()[0]
 
         if len(args)==1:
             C = args[0]
@@ -1718,10 +1720,12 @@
         """
 
         if not self._hold: self.cla()
-        shading = kwargs.get('shading', 'faceted')
-        cmap = kwargs.get('cmap', cm.get_cmap())
-        norm = kwargs.get('norm', normalize())
-        alpha = kwargs.get('alpha', 1.0)
+        shading = popd(kwargs,'shading', 'faceted')
+        cmap = popd(kwargs,'cmap', cm.get_cmap())
+        norm = popd(kwargs,'norm', normalize())
+        alpha = popd(kwargs,'alpha', 1.0)
+        if len(kwargs):
+            raise TypeError, 'Unknown argument "%s"'%kwargs.keys()[0]
 
         if len(args)==1:
             C = args[0]
@@ -2225,8 +2229,8 @@
 
         """
 
-        d = {'basex': kwargs.get('basex', 10),
-             'subsx': kwargs.get('subsx', None),
+        d = {'basex': popd(kwargs,'basex', 10),
+             'subsx': popd(kwargs,'subsx', None),
              }
              
         self.set_xscale('log', **d)
@@ -2252,8 +2256,8 @@
       range(2,basey)
 
         """
-        d = {'basey': kwargs.get('basey', 10),
-             'subsy': kwargs.get('subsy', None),
+        d = {'basey': popd(kwargs,'basey', 10),
+             'subsy': popd(kwargs,'subsy', None),
              }
         self.set_yscale('log', **d)
         dict_delall( kwargs, ('basey', 'subsy')) 